Whamcloud - gitweb
Branch b1_4
[fs/lustre-release.git] / build / lmake
1 #!/bin/sh
2
3 # option variables
4 DESTDIR=
5 KERNELDIR=
6 TARGET=
7 # Not sure what to put here
8 # TARGET_ARCH=$(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
9 TARGET_ARCH=
10 TARGET_CONFIG=
11 JOBS=1
12 CONFIGURE_FLAGS=
13
14 # commands to run
15 BUILD_LUSTRE=0
16 BUILD_KERNEL=0
17 DEPEND_KERNEL=0
18 INSTALL_LUSTRE=0
19 INSTALL_KERNEL=0
20 SAVE_HEADERS=0
21 UNPACK_KERNEL=0
22
23 # provided by target file
24 KERNEL=
25 SERIES=
26 CONFIG=
27 VERSION=
28 EXTRA_VERSION=
29
30 BASE_ARCHS=
31 BIGMEM_ARCHS=
32 BOOT_ARCHS=
33 JENSEN_ARCHS=
34 SMP_ARCHS=
35 BIGSMP_ARCHS=
36 PSERIES64_ARCHS=
37 UP_ARCHS=
38
39 RHBUILD=0
40 SUSEBUILD=0
41
42 # flat-out globals
43 TOPDIR=
44 TARGET_FILE=
45 KERNEL_FILE=
46 SERIES_FILE=
47 CONFIG_FILE=
48 RPMBUILD=
49
50 canon()
51 {
52     pushd $1 >/dev/null
53     echo $PWD
54     popd >/dev/null
55 }
56 TOPDIR="${0%%${0##*/}}"
57 if [ "${TOPDIR}" ] ; then
58     TOPDIR=$(canon "${TOPDIR}/..")
59 else
60     TOPDIR=$(canon "..")
61 fi
62
63 lbuild_topdir()
64 {
65     retdir=$TOPDIR
66     while [ ! -d $retdir/BUILD ] ; do
67         retdir=$(canon "$retdir/..")
68         if [ "$retdir" = "/" ] ; then
69             break;
70         fi
71     done
72     echo "$retdir"
73 }
74
75 cleanup()
76 {
77     true
78 }
79
80 fatal()
81 {
82     cleanup
83     [ "$2" ] && echo
84     [ "$2" ] && echo "${0##*/}: $2"
85     exit $1
86 }
87
88 list_targets()
89 {
90     echo -n "Available targets:"
91     for target in $TOPDIR/lustre/kernel_patches/targets/*.target ; do
92         target_file=${target##*/}
93         echo -n " ${target_file%%.target}"
94     done
95     echo
96 }
97
98
99 usage()
100 {
101     cat <<EOF
102 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
103
104 Options:
105
106   --build
107     same as --build-kernel --build-lustre --unpack-kernel
108
109   --build-lustre
110     configure and compile lustre.  Requires that --build-kernel was
111     already run.
112
113   --build-kernel
114     configure and compile a kernel.  Implies --depend-kernel.
115     Requires that --unpack-kernel was already run.
116
117   --depend-kernel)
118     Prepares a kernel tree for building (similar to make mrproper
119     oldconfig dep).  Requires that --unpack-kernel was already run.
120
121   --destdir=DESTDIR
122     Root directory to install into (like DESTDIR with auto*).
123
124   --extraversion=EXTRAVERSION
125     Overrides the target kernel\'s EXTRAVERSION text.
126
127   -h, --help
128     Display this message.
129
130   --install
131     same as --install-kernel --install-lustre
132
133   --install-lustre
134     run make install in the Lustre tree.
135
136   --install-kernel
137     install the kernel image and modules.
138
139   -j jobs
140     This works just like the -j option to make, and is passed to make
141     when building.
142
143   --kerneldir=KERNELDIR
144     Directory containing linux source tarballs.
145
146   --target=TARGET
147     Name of the configuration to use.  The available targets are
148     listed below.
149
150   --target-arch=ARCH
151     Specifies an architecture to use when choosing a kernel config
152     file.  Default is i386.
153
154   --target-config=CONFIG
155     Specifies a special option (such as smp, bigsmp, bigmem, or BOOT)
156     to use when choosing a kernel config file.  This also modifies the
157     kernel version and modules directory.
158
159   --unpack-kernel
160     Untars and patches the kernel source.
161
162   The order that commands (--build-lustre, --unpack-kernel) are
163   specified on the command line is ignored; ${0##*/} will always
164   execute them in the correct order (unpack, then build, then install
165   etc.).
166
167 EOF
168     list_targets
169
170     fatal "$1" "$2"
171 }
172
173 check_options()
174 {
175     (( $BUILD_LUSTRE || $BUILD_KERNEL || $DEPEND_KERNEL || \
176             $INSTALL_LUSTRE || $INSTALL_KERNEL || $SAVE_HEADERS || \
177             $UNPACK_KERNEL )) || \
178                 fatal 1 "No commands specified."
179
180     if (( $UNPACK_KERNEL )) ; then
181         [ "$KERNELDIR" ] || \
182             fatal 1 "A kernel directory must be specified with --kerneldir."
183         [ -d "$KERNELDIR" ] || \
184             fatal 1 "$KERNELDIR is not a directory."
185     fi
186
187     if (( $INSTALL_LUSTRE || $INSTALL_KERNEL || $SAVE_HEADERS )) ; then
188         [ -z "$DESTDIR" -o -d "$DESTDIR" ] || \
189             fatal 1 "$DESTDIR is not a directory."
190     fi
191
192     [ "$TARGET" ] || usage 1 "A target must be specified with --target."
193     TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
194     [ -r "$TARGET_FILE" ] || \
195         fatal 1 "Target '$TARGET' was not found.  Try --list-targets."
196
197     if [ -z "$JOBS" -o "$JOBS" -lt "1" ] ; then
198         JOBS=1
199     fi
200
201     RPMBUILD=$(which rpmbuild 2>/dev/null | head -1)
202     if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
203         RPMBUILD=$(which rpm 2>/dev/null | head -1)
204         if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
205             usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
206         fi
207     fi
208 }
209
210 get_lustre_version()
211 {
212     for series in $SERIES ; do
213         SERIES_FILE="$TOPDIR/lustre/kernel_patches/series/$series"
214         lustre_patch=$(grep lustre_version "$SERIES_FILE" 2>/dev/null)
215         [ "$lustre_patch" ] && break
216     done
217     [ "$lustre_patch" ] || \
218         fatal 1 "Could not determine Lustre version from $SERIES series."
219
220     awk '/^\+#define LUSTRE_KERNEL_VERSION /{ print $3 }' \
221         "$TOPDIR/lustre/kernel_patches/patches/$lustre_patch" 2>/dev/null
222 }
223
224 load_target()
225 {
226     EXTRA_VERSION_save="$EXTRA_VERSION"
227
228     . "$TARGET_FILE"
229
230     [ "$KERNEL" ] || fatal 1 "Target $TARGET did not specify a kernel."
231 # Suse 2.6 has our patches in already
232 #    [ "$SERIES" ] || fatal 1 "Target $TARGET did not specify a patch series."
233 #    [ "$CONFIG" ] || fatal 1 "Target $TARGET did not specify a kernel config."
234     [ "$VERSION" ] || fatal 1 "Target $TARGET did not specify the kernel version."
235     
236     if [ "$KERNELDIR" ] ; then
237         KERNEL_FILE="$KERNELDIR/$KERNEL"
238         [ -r "$KERNELDIR/$KERNEL" ] || \
239             fatal 1 "Target $TARGET's kernel file $KERNEL not found in kernel directory $KERNELDIR."
240     fi
241
242     if [ "$SERIES" ] ; then
243         for series in $SERIES ; do
244             SERIES_FILE="$TOPDIR/lustre/kernel_patches/series/$series"
245             [ -r "$SERIES_FILE" ] || \
246                 fatal 1 "Target $TARGET's series $SERIES missing from $TOPDIR/lustre/kernel_patches/series."
247         done
248     fi
249
250     TARGET_ARCH=${TARGET_ARCH:-$BASE_ARCHS}
251     CONFIG_TARGET="$TARGET-${TARGET_ARCH}${TARGET_CONFIG:+-$TARGET_CONFIG}"
252     CONFIG_FILE="$TOPDIR/lustre/kernel_patches/kernel_configs/kernel-$VERSION-$CONFIG_TARGET.config"
253     [ -r "$CONFIG_FILE" ] ||
254         fatal 1 "Target $TARGET's config file $CONFIG_FILE missing from $TOPDIR/lustre/kernel_patches/configs."
255
256     if [ "$EXTRA_VERSION_save" ] ; then
257         EXTRA_VERSION="$EXTRA_VERSION_save"
258     else
259         EXTRA_VERSION="${EXTRA_VERSION}_lustre.$(get_lustre_version)"
260     fi
261 }
262
263 tarflags()
264 {
265     case "$1" in
266         '')
267             fatal 1 "tarflags(): File name argument missing."
268             ;;
269         *.tar.gz | *.tgz)
270             echo 'zxf'
271             ;;
272         *.tar.bz2)
273             echo 'jxf'
274             ;;
275         *.tar)
276             echo 'xf'
277             ;;
278         *)
279             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
280             ;;
281     esac
282 }
283
284 untar()
285 {
286     echo "Untarring ${1##*/}..."
287     tar $(tarflags $1) $1
288 }
289
290
291 extract_kernel()
292 {
293     (( $UNPACK_KERNEL )) || return 0
294     pushd "$TOPDIR" >/dev/null
295     if [ -d linux ] ; then
296         [ -L linux ] && rm -rf $(readlink linux)
297         rm -rf linux
298     fi
299     untar "$KERNEL_FILE"
300     [ -d linux ] || ln -sf linux* linux
301     popd >/dev/null
302 }
303
304 patch_kernel()
305 {
306     (( $UNPACK_KERNEL )) || return 0
307     [ "$SERIES" ] || return 0
308     pushd "$TOPDIR/linux" >/dev/null
309     for series in $SERIES ; do
310         echo -n "Applying series $series:"
311         SERIES_FILE="$TOPDIR/lustre/kernel_patches/series/$series"
312         for patch in $(<"$SERIES_FILE") ; do
313             PATCH_FILE="$TOPDIR/lustre/kernel_patches/patches/$patch"
314             [ -r "$PATCH_FILE" ] || \
315                 fatal 1 "Patch file not found: $patch"
316             echo -n " $patch"
317             patch -s -p1 < "$PATCH_FILE" || fatal 1 "Error applying patch $patch."
318         done
319         echo
320     done
321     popd >/dev/null
322 }
323
324 set_make()
325 {
326     MAKE="make -s"
327     if [ "$CC" ] ; then
328         MAKE_CC="CC=$CC"
329     fi
330     if [ "$ARCH" ] ; then
331         MAKE_ARCH="$MAKE ARCH=$ARCH"
332     else
333         case $TARGET_ARCH in
334             i?86)
335                 ;;
336             *)
337                 MAKE_ARCH="$MAKE ARCH=$TARGET_ARCH"
338                 ;;
339         esac
340     fi
341     MAKE_J="$MAKE -j $JOBS"
342 }
343
344 timed_run() {
345     SLEEP_TIME=$1
346     shift
347
348     set -o monitor
349
350     #bash -c "$@" &
351     ("$@") &
352     child_pid=$!
353     
354     (sleep $SLEEP_TIME
355     kill -TERM -$child_pid 2>/dev/null
356     sleep 5
357     kill -KILL -$child_pid 2>/dev/null
358     echo "$1 was killed due to timeout") &
359     dog_pid=$!
360
361     wait $child_pid
362     # status will be set to 143 if the process had to be killed due to timeout
363     status=$?
364     kill -KILL -$dog_pid
365     return $status
366 }
367
368 depend_kernel()
369 {
370     (( $DEPEND_KERNEL )) || return 0
371     # we need to override $CC at make time, since there is no
372     # configure
373     set_make
374     pushd "$TOPDIR/linux" >/dev/null
375     echo "Overriding EXTRAVERSION in kernel..."
376     perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -${EXTRA_VERSION}${TARGET_CONFIG}/" Makefile
377     echo "Making depend in $PWD..."
378     $MAKE "$MAKE_CC" mrproper || fatal 1 "Error running make mrproper"
379     rm -f rpm-release
380     cp "$CONFIG_FILE" .config
381     # use the expect script to "make oldconfig" and answer the questions for
382     # new items conservatively.  QA will get notified on anything newly added
383     # for them to review and adjust accordingly.
384     timed_run 300 $TOPDIR/build/update_oldconfig
385     if [ $? -eq 143 ]; then
386         fatal 1 "update_oldconfig timed out"
387     fi
388     # now notify if resulting .config is different than $CONFIG_FILE
389     local tmpfile=$(mktemp /tmp/XXXXXX)
390     diff -I '^#.*' -u "$CONFIG_FILE" .config >$tmpfile
391     if [ -s $tmpfile ]; then
392         { cat <<EOF
393 To: qa@lists.clusterfs.com
394 Subject: kernel_config change 
395
396 The result of a make oldconfig on file $CONFIG_FILE resulted in a
397 difference when compared to .config in the following way:
398
399 EOF
400         cat $tmpfile
401         echo -e "\n\nPlease consider updating $CONFIG_FILE."
402         # not sure these are entirely useful.  the above and "patch" are good
403         #echo -e "\nThe entire new .config file:\n"
404         #cat .config
405         } | sendmail -fqa@clusterfs.com -t
406     fi
407     rm -f $tmpfile
408     case "$VERSION" in
409         2.6*)
410             $MAKE "$MAKE_CC" include/asm
411             ;;
412         2.4*)
413             $MAKE "$MAKE_CC" symlinks
414             $MAKE "$MAKE_CC" dep || fatal 1 "Error running make dep"
415             ;;
416     esac
417     $MAKE "$MAKE_CC" include/linux/version.h || fatal 1 "Error making include/linux/version.h"
418 }
419
420 build_kernel()
421 {
422     (( $BUILD_KERNEL )) || return 0
423     set_make
424     echo "Building kernel in $PWD..."
425     case "$TARGET_ARCH" in
426         i386 | i586 | i686 | athlon | x86_64)
427             $MAKE_J "$MAKE_CC" bzImage || fatal 1 "Error making bzImage."
428             ;;
429     ia64 | ppc | ppc64)
430             $MAKE_J "$MAKE_CC" vmlinux || fatal 1 "Error making vmlinux."
431             ;;
432         *)
433             $MAKE_J "$MAKE_CC" boot || fatal 1 "Error making boot."
434             ;;
435     esac
436     $MAKE_J "$MAKE_CC" modules || fatal 1 "Error building modules."
437
438     popd >/dev/null
439 }
440
441 configure_lustre()
442 {
443     return 0
444     (( $BUILD_LUSTRE )) || return 0
445     pushd "$TOPDIR" >/dev/null
446     [ -f Makefile ] && make -s clean
447     [ -f configure ] || sh ./autogen.sh
448     ./configure --with-linux=$PWD/linux $CONFIGURE_FLAGS || \
449         fatal 1 "Error configuring Lustre."
450     popd >/dev/null
451 }
452
453 build_lustre()
454 {
455     (( $BUILD_LUSTRE )) || return 0
456     set_make
457     FULL_VERSION="${VERSION}-${EXTRA_VERSION}${TARGET_CONFIG}"
458     pushd "$TOPDIR" >/dev/null
459     sed \
460         -e s^@VERSION@^${LUSTRE_VERSION}^g \
461         -e s^@LINUXRELEASE@^${FULL_VERSION}^g \
462         -e s^@RELEASE@^${FULL_VERSION//-/_}^g \
463         -e s^@ac_configure_args@^"--with-linux=${PWD}/linux ${CONFIGURE_FLAGS}"^g \
464         < build/lustre.spec.in \
465         > build/lustre.spec
466     $RPMBUILD --target ${TARGET_ARCH} -bb build/lustre.spec \
467         --define "_topdir $(lbuild_topdir)" || \
468         fatal 1 "Error building Lustre rpms."
469     # $MAKE_J "$MAKE_CC" || fatal 1 "Error building Lustre."
470     popd >/dev/null
471 }
472
473 install_kernel()
474 {
475     (( $INSTALL_KERNEL )) || return 0
476     set_make
477     FULL_VERSION="${VERSION}-${EXTRA_VERSION}${TARGET_CONFIG}"
478     pushd "$TOPDIR/linux" >/dev/null
479     mkdir -p "$DESTDIR/boot"
480
481     install -m 644 System.map "$DESTDIR/boot/System.map-${FULL_VERSION}"
482     # install -m 644 module-info ...
483     install -m 644 "$CONFIG_FILE" "$DESTDIR/boot/config-${FULL_VERSION}"
484
485     mkdir -p "$DESTDIR/dev/shm"
486     mkdir -p "$DESTDIR/lib/modules/${FULL_VERSION}"
487
488     $MAKE "$MAKE_CC" INSTALL_MOD_PATH="$DESTDIR" KERNELRELEASE="$FULL_VERSION" \
489         -s modules_install || \
490         fatal 1 "Error installing modules."
491
492     case "$TARGET_ARCH" in
493         i386 | i586 | i686 | athlon)
494             cp arch/i386/boot/bzImage "$DESTDIR/boot/vmlinuz-${FULL_VERSION}"
495             cp vmlinux "$DESTDIR/lib/modules/${FULL_VERSION}/"
496             ln -sf "../lib/modules/${FULL_VERSION}/vmlinux" "$DESTDIR/boot/vmlinux-${FULL_VERSION}"
497             ;;
498         x86_64)
499             cp arch/x86_64/boot/bzImage "$DESTDIR/boot/vmlinuz-${FULL_VERSION}"
500             cp vmlinux "$DESTDIR/lib/modules/${FULL_VERSION}/"
501             ln -sf "../lib/modules/${FULL_VERSION}/vmlinux" "$DESTDIR/boot/vmlinux-${FULL_VERSION}"
502             ;;
503         ppc | ppc64)
504             cp vmlinux "$DESTDIR/boot/vmlinux-${FULL_VERSION}"
505             ln -sf "$DESTDIR/boot/vmlinux-${FULL_VERSION}" "../lib/modules/${FULL_VERSION}/vmlinux" 
506             ;;
507         ia64)
508             gzip -cfv vmlinux > vmlinuz
509             mkdir -p "$DESTDIR/boot/efi/redhat"
510             install -m 755 vmlinux "$DESTDIR/lib/modules/${FULL_VERSION}/"
511             install -m 755 vmlinuz "$DESTDIR/boot/efi/redhat/vmlinuz-${FULL_VERSION}"
512             ln -sf "../../../lib/modules/${FULL_VERSION}/vmlinux" "$DESTDIR/boot/efi/redhat/vmlinux-${FULL_VERSION}"
513             ln -sf "efi/redhat/vmlinux-${FULL_VERSION}" "$DESTDIR/boot/vmlinux-${FULL_VERSION}"
514             ln -sf "efi/redhat/vmlinuz-${FULL_VERSION}" "$DESTDIR/boot/vmlinuz-${FULL_VERSION}"
515             ;;
516         *)
517             cp vmlinuz "$DESTDIR/boot/vmlinuz-${FULL_VERSION}"
518             cp vmlinux "$DESTDIR/lib/modules/${FULL_VERSION}/vmlinux-${FULL_VERSION}"
519             ln -sf "../lib/modules/${FULL_VERSION}/vmlinux-${FULL_VERSION}" "$DESTDIR/boot/vmlinux-${FULL_VERSION}"
520
521             ;;
522     esac
523     if [ -e init/kerntypes.o ] ; then
524         cp init/kerntypes.o "$DESTDIR/boot/Kerntypes-${FULL_VERSION}"
525     fi
526
527     popd >/dev/null
528 }
529
530 cleanup_libmodules()
531 {
532     (( $INSTALL_LUSTRE )) || return 0
533
534     FULL_VERSION="${VERSION}-${EXTRA_VERSION}${TARGET_CONFIG}"
535     KVERREL="${VERSION}-${EXTRA_VERSION}"
536     i="$DESTDIR/lib/modules/${FULL_VERSION}"
537
538     rm -f $i/build
539     rm -f $i/source
540
541     if (( $LINUX26 )) ; then
542         ln -sf ../../../usr/src/linux-${KVERREL}-obj/${TARGET_ARCH}/${TARGET_CONFIG} $i/build
543         ln -sf ../../../usr/src/linux-${KVERREL} $i/source
544     else
545         ln -sf ../../../usr/src/linux-${KVERREL} $i/build
546     fi
547 }
548
549 install_lustre()
550 {
551     (( $INSTALL_LUSTRE )) || return 0
552     return 0
553     set_make
554     FULL_VERSION="${VERSION}-${EXTRA_VERSION}${TARGET_CONFIG}"
555     pushd "$TOPDIR" >/dev/null
556     $MAKE "$MAKE_CC" -s install "DESTDIR=$DESTDIR" KERNELRELEASE="$FULL_VERSION" || fatal 1 "Error installing Lustre."
557     popd >/dev/null
558 }
559
560 build_kms()
561 {
562     (( $BUILD_KERNEL )) || return 0
563     (( $SUSEBUILD )) || return 0
564     set_make
565     FULL_VERSION="${VERSION}-${EXTRA_VERSION}${TARGET_CONFIG}"
566     mkdir -p "${TOPDIR}/modules-${FULL_VERSION}"
567     for dir in /usr/src/kernel-modules/* ; do
568         # we are replacing lustre-lite, so don't include it
569         if [ "${dir##*/}" != "lustre-lite" -a -e $dir/Makefile ]; then
570             build_dir="${TOPDIR}/modules-${FULL_VERSION}/${dir##*/}"
571             cp -a $dir $build_dir
572             # these modules are terrible, and don't all build
573             $MAKE_J "$MAKE_CC" -C $build_dir modules KERNEL_SOURCE="${TOPDIR}/linux"
574         fi
575     done
576 }
577
578 symver()
579 {
580     local file=$1 name=${1%.ko}
581     nm $file \
582     | sed -ne 's,^0*\([0-9a-f]\{8\}\) A __crc_\(.*\),0x\1\t\2\t'"$name"',p'
583 }
584
585 install_kms()
586 {
587     (( $INSTALL_KERNEL )) || return 0
588     (( $LINUX26 )) || return 0
589     set_make
590     FULL_VERSION="${VERSION}-${EXTRA_VERSION}${TARGET_CONFIG}"
591     for build_dir in "${TOPDIR}/modules-${FULL_VERSION}/*" ; do
592         [ -d $build_dir ] || continue
593         # these modules are terrible, and don't all build
594         $MAKE "$MAKE_CC" -C $build_dir KERNEL_SOURCE="${TOPDIR}/linux" INSTALL_MOD_PATH="$DESTDIR" 
595     done
596     (   symver vmlinux
597         moddir="${DESTDIR}/lib/modules/${FULL_VERSION}"
598         cd $moddir/kernel
599         for module in $(find * -name '*.ko'); do
600             symver $module
601         done
602         cd $moddir
603         for module in $(find * -path 'kernel/*' -prune -o \
604                            -name '*.ko' -print); do
605             symver $module
606         done
607     ) | sort -u -k2 \
608         | gzip -c9 > "${DESTDIR}/boot/symvers-${VERSION}-${EXTRA_VERSION}-${TARGET_ARCH}${TARGET_CONFIG}.gz"
609 }
610
611 save_headers()
612 {
613     (( $SAVE_HEADERS )) || return 0
614
615     echo "Saving headers for ${TARGET_CONFIG:-up} ${TARGET_ARCH}..."
616     pushd linux >/dev/null
617
618     KVERREL="${VERSION}-${EXTRA_VERSION}"
619     # deal with the kernel headers that are version specific
620     
621     saveddir="$RPM_BUILD_ROOT/usr/src/linux-${KVERREL}/savedheaders/${TARGET_ARCH}/${TARGET_CONFIG:-up}"
622     mkdir -p "$saveddir"
623     install -m 644 include/linux/autoconf.h "$saveddir/autoconf.h"
624     install -m 644 include/linux/version.h  "$saveddir/version.h"
625     mv include/linux/modules "$saveddir/"
626     echo ${TARGET_ARCH} ${TARGET_CONFIG} ../../savedheaders/${TARGET_ARCH}/${TARGET_CONFIG:-up}/ \
627         >>  "$RPM_BUILD_ROOT/usr/src/linux-${KVERREL}/savedheaders/list"
628     popd >/dev/null
629 }
630
631 save_all_headers()
632 {
633     (( $SAVE_HEADERS )) || return 0
634
635     for arch in $BIGMEM_ARCHS ; do
636         save_headers bigmem $arch
637     done
638
639     for arch in $BOOT_ARCHS ; do
640         save_headers BOOT $arch
641     done
642
643     for arch in $JENSEN_ARCHS ; do
644         save_headers jensen $arch
645     done
646
647     for arch in $SMP_ARCHS ; do
648         save_headers smp $arch
649     done
650
651     for arch in $BIGSMP_ARCHS ; do
652         save_headers bigsmp $arch
653     done
654     for arch in $PSERIES64_ARCHS ; do
655         save_headers pseries64 $arch
656     done
657     for arch in $UP_ARCHS ; do
658         save_headers up $arch
659     done
660 }
661
662 longopts="build,build-lustre,build-kernel,depend-kernel,destdir:,extraversion:"
663 longopts="$longopts,help,install,install-lustre,install-kernel,kerneldir:"
664 longopts="$longopts,save-headers,target:,target-arch:,target-config:,unpack-kernel"
665
666 options=$(getopt -o hj: -l "$longopts" -- "$@")
667
668 eval set -- "$options"
669     
670 while [ "$1" ] ; do
671     case "$1" in
672         '')
673             usage 1
674             ;;
675         --build)
676             BUILD_LUSTRE=1
677             BUILD_KERNEL=1
678             DEPEND_KERNEL=1
679             UNPACK_KERNEL=1
680             shift
681             ;;
682         --build-lustre)
683             BUILD_LUSTRE=1
684             shift
685             ;;
686         --build-kernel)
687             BUILD_KERNEL=1
688             DEPEND_KERNEL=1
689             shift
690             ;;
691         --depend-kernel)
692             DEPEND_KERNEL=1
693             shift
694             ;;
695         --destdir)
696             DESTDIR=$2
697             shift 2
698             ;;
699         --extraversion)
700             EXTRA_VERSION=$2
701             shift 2
702             ;;
703         --help | -h)
704             usage 0
705             ;;
706         --install)
707             INSTALL_LUSTRE=1
708             INSTALL_KERNEL=1
709             shift
710             ;;
711         --install-lustre)
712             INSTALL_LUSTRE=1
713             shift
714             ;;
715         --install-kernel)
716             INSTALL_KERNEL=1
717             shift
718             ;;
719         -j)
720             JOBS=$2
721             shift 2
722             ;;
723         --kerneldir)
724             KERNELDIR=$2
725             shift 2
726             ;;
727         --save-headers)
728             SAVE_HEADERS=1
729             shift
730             ;;
731         --target)
732             TARGET=$2
733             shift 2
734             ;;
735         --target-arch)
736             TARGET_ARCH=$2
737             shift 2
738             ;;
739         --target-config)
740             TARGET_CONFIG=$2
741             shift 2
742             ;;
743         --unpack-kernel)
744             UNPACK_KERNEL=1
745             shift
746             ;;
747         --)
748             shift
749             CONFIGURE_FLAGS=$@
750             break
751             ;; 
752         *)
753             usage 1 "Unrecognized option: $1"
754             ;;
755     esac
756 done
757
758 check_options
759 load_target
760
761 extract_kernel
762 patch_kernel
763
764 depend_kernel
765 build_kernel
766
767 configure_lustre
768 build_lustre
769
770 build_kms
771
772 install_kernel
773 install_lustre
774
775 install_kms
776
777 cleanup_libmodules
778
779 save_headers
780
781 exit 0